c
c
c Plotting routines
c
c
      subroutine initplot
      implicit none
c Book histograms in this routine. Use mbook or bookup. The entries
c of these routines are real*8
      double precision emax,ebin,etamin,etamax,etabin
      integer i,kk
      include 'run.inc'
      character*5 cc(2)
      data cc/' NLO ',' Born'/
c
      emax=dsqrt(ebeam(1)*ebeam(2))
      ebin=emax/50.d0
      etamin=-5.d0
      etamax=5.d0
      etabin=0.2d0
c resets histograms
      call inihist
c
      do i=1,2
        kk=(i-1)*50
        call bookup(kk+1,'total rate'//cc(i),1.0d0,0.5d0,5.5d0)
        call bookup(kk+2,'eta j1'//cc(i),0.3d0,-6d0,6d0)
        call bookup(kk+3,'eta j2'//cc(i),0.3d0,-6d0,6d0)
        call bookup(kk+4,'y j1'//cc(i),0.3d0,-6d0,6d0)
        call bookup(kk+5,'y j2'//cc(i),0.3d0,-6d0,6d0)
        call bookup(kk+6,'Pt j1'//cc(i),50d0,0d0,1000d0)
        call bookup(kk+7,'Pt j2'//cc(i),50d0,0d0,1000d0)
        call bookup(kk+8,'Ht'//cc(i),50d0,0d0,1000d0)
      enddo
      return
      end


      subroutine topout
      implicit none
      character*14 ytit
      logical usexinteg,mint
      common/cusexinteg/usexinteg,mint
      integer itmax,ncall
      common/citmax/itmax,ncall
      real*8 xnorm1,xnorm2
      logical unwgt
      double precision evtsgn
      common /c_unwgt/evtsgn,unwgt
      integer i,kk
c
      if (unwgt) then
         ytit='events per bin'
      else
         ytit='sigma per bin '
      endif
      xnorm1=1.d0/float(itmax)
      xnorm2=1.d0/float(ncall*itmax)
      do i=1,500
        if(usexinteg.and..not.mint) then
           call mopera(i,'+',i,i,xnorm1,0.d0)
        elseif(mint) then
           call mopera(i,'+',i,i,xnorm2,0.d0)
        endif
        call mfinal(i)
      enddo
      do i=1,2
        kk=(i-1)*50
        call multitop(kk+1,3,2,'total rate',ytit,'LIN')
        call multitop(kk+2,3,2,'eta j1    ',ytit,'LOG')
        call multitop(kk+3,3,2,'eta j2    ',ytit,'LOG')
        call multitop(kk+4,3,2,'y j1      ',ytit,'LOG')
        call multitop(kk+5,3,2,'y j2      ',ytit,'LOG')
        call multitop(kk+6,3,2,'Pt j1     ',ytit,'LOG')
        call multitop(kk+7,3,2,'Pt j2     ',ytit,'LOG')
        call multitop(kk+7,3,2,'Ht        ',ytit,'LOG')

      enddo
      return                
      end


      subroutine outfun(pp,ybst_til_tolab,www,itype)
C
C *WARNING**WARNING**WARNING**WARNING**WARNING**WARNING**WARNING**WARNING*
C
C In MadFKS, the momenta PP given in input to this function are in the
C reduced parton c.m. frame. If need be, boost them to the lab frame.
C The rapidity of this boost is
C
C       YBST_TIL_TOLAB
C
C also given in input
C
C This is the rapidity that enters in the arguments of the sinh() and
C cosh() of the boost, in such a way that
C       ylab = ycm - ybst_til_tolab
C where ylab is the rapidity in the lab frame and ycm the rapidity
C in the center-of-momentum frame.
C
C *WARNING**WARNING**WARNING**WARNING**WARNING**WARNING**WARNING**WARNING*
      implicit none
      include 'nexternal.inc'
      real*8 pp(0:3,nexternal),ybst_til_tolab,www
      integer itype
      real*8 var
      real*8 ppevs(0:3,nexternal)

      real*8 getrapidity,getpseudorap,chybst,shybst,chybstmo
      real*8 xd(1:3)
      data (xd(i),i=1,3)/0,0,1/
      real*8 pplab(0:3,nexternal)
      double precision ppcl(4,nexternal),y(nexternal)
      double precision pjet(0:3,nexternal)
      double precision cthjet(nexternal)
      integer nn,njet,nsub,jet(nexternal)
      real*8 emax,getcth,cpar,dpar,thrust,dot,shat
      integer i,j,kk,imax

      LOGICAL  IS_A_J(NEXTERNAL),IS_A_L(NEXTERNAL)
      LOGICAL  IS_A_B(NEXTERNAL),IS_A_A(NEXTERNAL)
      LOGICAL  IS_A_NU(NEXTERNAL),IS_HEAVY(NEXTERNAL)
      COMMON /TO_SPECISA/IS_A_J,IS_A_A,IS_A_L,IS_A_B,IS_A_NU,IS_HEAVY
c masses
      double precision pmass(nexternal)
      double precision  pt1, eta1, y1, pt2, eta2, y2,ht

      common/to_mass/pmass
      double precision ppkt(0:3,nexternal),ecut,djet
      double precision ycut, palg
      integer ipartjet(nexternal)

c
      if(itype.eq.11.or.itype.eq.12)then
        kk=0
      elseif(itype.eq.20)then
        kk=50
      else
        write(*,*)'Error in outfun: unknown itype',itype
        stop
      endif

      chybst=cosh(ybst_til_tolab)
      shybst=sinh(ybst_til_tolab)
      chybstmo=chybst-1.d0
      do i=3,nexternal
        call boostwdir2(chybst,shybst,chybstmo,xd,
     #                  pp(0,i),pplab(0,i))
      enddo



c now find jets
c First relabel momenta
      NN=0
      do j=nincoming+1,nexternal
         if (is_a_j(j))then
            NN=NN+1
            do i=1,4
               ppkt(i,NN)=pplab(i,j)
            enddo
         endif
      enddo

      ECUT=1d0
      DJET=0.7d0
      YCUT=30d0
      palg=1d0
c      1.0=kt, 0.0=C/A, -1.0 = anti-kt
c      call ktclus_nbi(pplab,NN,djet,ycut,-1,pjet,njet,ipartjet)

ccc----FOR FJ v < 3.0
c      call fastjetppgenkt(ppkt,NN,djet,ycut,palg,pjet,njet,ipartjet)

ccc----FOR FJ v > 3.0
      call fastjetppgenkt(ppkt,NN,djet,palg,pjet,njet)
ccc---      
      if (njet .ge.2) then
        pt1=dsqrt(pjet(1,1)**2+pjet(2,1)**2)
        eta1= getpseudorap(pjet(0,1),pjet(1,1),pjet(2,1),pjet(3,1))
        y1= getrapidity(pjet(0,1),pjet(3,1))
        pt2=dsqrt(pjet(1,2)**2+pjet(2,2)**2)
        eta2= getpseudorap(pjet(0,2),pjet(1,2),pjet(2,2),pjet(3,2))
        y2= getrapidity(pjet(0,2),pjet(3,2))

        ht=0d0
        do i=1,njet
            ht= ht+dsqrt(pjet(1,i)**2+pjet(2,i)**2)
        enddo


        call mfill(kk+2,eta1,www)
        call mfill(kk+3,eta2,www)
        call mfill(kk+4,y1,www)
        call mfill(kk+5,y2,www)
        call mfill(kk+6,pt1,www)
        call mfill(kk+7,pt2,www)
        call mfill(kk+7,ht,www)
        var=1.d0
        call mfill(kk+1,var,www)
      endif
          



 999  return      
      end


      function getrapidity(en,pl)
      implicit none
      real*8 getrapidity,en,pl,tiny,xplus,xminus,y
      parameter (tiny=1.d-8)
c
      xplus=en+pl
      xminus=en-pl
      if(xplus.gt.tiny.and.xminus.gt.tiny)then
        if( (xplus/xminus).gt.tiny.and.(xminus/xplus).gt.tiny )then
          y=0.5d0*log( xplus/xminus )
        else
          y=sign(1.d0,pl)*1.d8
        endif
      else
        y=sign(1.d0,pl)*1.d8
      endif
      getrapidity=y
      return
      end


      function getpseudorap(en,ptx,pty,pl)
      implicit none
      real*8 getpseudorap,en,ptx,pty,pl,tiny,pt,eta,th
      parameter (tiny=1.d-5)
c
      pt=sqrt(ptx**2+pty**2)
      if(pt.lt.tiny.and.abs(pl).lt.tiny)then
        eta=sign(1.d0,pl)*1.d8
      else
        th=atan2(pt,pl)
        eta=-log(tan(th/2.d0))
      endif
      getpseudorap=eta
      return
      end

