C+-----------------------------------------------------------------------+
C|                         MAIN CODE FOR MADWEIGHT                       |
C|                                                                       |
C|     Author: Pierre Artoisenet (UCL-CP3)                               |
C|             Olivier Mattelaer (UCL-CP3)                               |
C+-----------------------------------------------------------------------+
C|     This file is generated automaticly by MADWEIGHT-ANALYZER          |
C+-----------------------------------------------------------------------+     
      subroutine main_code(x,n_var)
C+-----------------------------------------------------------------------+
C|     Central Routine for the change of variable choice                 |
C|       - num_sol: number of the solution to charge                     |
C|       - x      : random number from vegas                             |
C+-----------------------------------------------------------------------+

	integer config,perm_pos
	common /to_config/ config,perm_pos
	double precision x(20)
	integer n_var
	double precision    S,X1,X2,PSWGT,JAC
        common /PHASESPACE/ S,X1,X2,PSWGT,JAC
c
	double precision multi_channel_weight
	external multi_channel_weight
c
	include 'd_choices.inc'
C+-----------------------------------------------------------------------+
C|     Scedullar Part					                 |
C+-----------------------------------------------------------------------+    

       if (config.eq.1) then 

C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: B                                                           |
C|    particle in ECS : 5(missing)    4(visible)                         |
C|    blob linked are generated by :-4                                   |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+



        call block_d(x,n_var,first_d_7_8, second_d_7_8,-2)
        call block_stat(1,'D-7')
        if (jac.le.0d0) return

C       ++++++++++++           
        call block_d(x,n_var,6, -2, -4)
        call block_stat(2,'D-6')
        if (jac.le.0d0) return

        call class_b(5,4,-1)
        call block_stat(3,'b-5')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(1)

       elseif (config.eq.2) then 

C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: B                                                           |
C|    particle in ECS : 5(missing)    4(visible)                         |
C|    blob linked are generated by :-4                                   |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+



        call block_e(x,n_var,8,7,6,-2,-4)
        call block_stat(1,'E-8')
        if (jac.le.0d0) return

        call class_b(5,4,-1)
        call block_stat(2,'b-5')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(2)

       elseif (config.eq.3) then 

C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: B                                                           |
C|    particle in ECS : 5(missing)    4(visible)                         |
C|    blob linked are generated by :-4                                   |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+



        call fuse(7,8,-2)
        call block_stat(1,'1-7')
        if (jac.le.0d0) return

C       ++++++++++++           
        call fuse(6,-2,-4)
        call block_stat(2,'1-6')
        if (jac.le.0d0) return

        call class_b(5,4,-1)
        call block_stat(3,'b-5')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(3)

       elseif (config.eq.4) then 
C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: B                                                           |
C|    particle in ECS : 5(missing)    a(fuse)                            |
C|    blob linked are generated by :-4                                   |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+




        call block_d(x,n_var,first_d_7_8, second_d_7_8,-2)
        call block_stat(1,'D-7')
        if (jac.le.0d0) return

C       ++++++++++++           
        call block_d(x,n_var,6, -2, -4)
        call block_stat(2,'D-6')
        if (jac.le.0d0) return

        call fuse(4,3,9)
        call block_stat(3,'2-4')
        if (jac.le.0d0) return

        call class_b(5,9,-3)
        call block_stat(4,'b-5')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(4)

       elseif (config.eq.5) then 
C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: B                                                           |
C|    particle in ECS : 5(missing)    a(fuse)                            |
C|    blob linked are generated by :-4                                   |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+




        call block_e(x,n_var,8,7,6,-2,-4)
        call block_stat(1,'E-8')
        if (jac.le.0d0) return

        call fuse(4,3,9)
        call block_stat(2,'2-4')
        if (jac.le.0d0) return

        call class_b(5,9,-3)
        call block_stat(3,'b-5')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(5)

       elseif (config.eq.6) then 
C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: B                                                           |
C|    particle in ECS : 5(missing)    a(fuse)                            |
C|    blob linked are generated by :-4                                   |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+




        call fuse(7,8,-2)
        call block_stat(1,'1-7')
        if (jac.le.0d0) return

C       ++++++++++++           
        call fuse(6,-2,-4)
        call block_stat(2,'1-6')
        if (jac.le.0d0) return

        call fuse(4,3,9)
        call block_stat(3,'2-4')
        if (jac.le.0d0) return

        call class_b(5,9,-3)
        call block_stat(4,'b-5')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(6)

        endif
        return
        end
