      program symmetry
c*****************************************************************************
c     Given identical particles, and the configurations. This program identifies
c     identical configurations and specifies which ones can be skipped
c*****************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'      
      include "nexternal.inc"
      include '../../Source/run_config.inc'
      
      double precision ZERO
      parameter       (ZERO = 0d0)
      integer   maxswitch
      parameter(maxswitch=99)
      integer lun
      parameter (lun=28)
c
c     Local
c
      integer iforest(2,-max_branch:-1,lmaxconfigs)
      integer mapconfig(0:lmaxconfigs)
      integer sprop(-max_branch:-1,lmaxconfigs)
      integer itree(2,-max_branch:-1)
      integer imatch
      integer use_config(0:lmaxconfigs)
      integer i,j, k, n, nsym
      double precision diff,rwgt
      double precision pmass(-max_branch:-1,lmaxconfigs)   !Propagotor mass
      double precision pwidth(-max_branch:-1,lmaxconfigs)  !Propagotor width
      integer pow(-max_branch:-1,lmaxconfigs)

      integer biforest(2,-max_branch:-1,lmaxconfigs)
      integer fksmother,fksgrandmother,fksaunt
      integer fksconfiguration!,mapbconf(0:lmaxconfigs)
      logical searchforgranny,is_beta_cms,is_granny_sch,topdown
      integer nbranch,ns_channel,nt_channel
      include "fks.inc"
c
c     Local for generating amps
c
      double complex wgt1(2)
      double precision p(0:3,99), wgt, x(99), fx
      double precision p1(0:3,99)
      double precision p1_cnt1(0:3,nexternal,-2:2),p_born1(0:3,nexternal-1),p_ev_red_save(0:3,nexternal-1)
      double precision p1_cnt_save(0:3,nexternal,-2:2),p_born_save(0:3,nexternal-1),p_ev_red1(0:3,nexternal-1)
      integer ninvar, ndim, iconfig, minconfig, maxconfig
      integer ncall,itmax,nconfigs,ntry, ngraphs
      integer ic(nexternal,maxswitch), icb(nexternal-1,maxswitch),jc(12),nswitch
      double precision saveamp(maxamps)
      integer nmatch, ibase
      logical mtc, even

c
c     Global
c
      Double Precision amp2(maxamps), jamp2(0:maxamps)
      common/to_amps/  amp2,       jamp2
      include 'coupl.inc'

      double precision p1_cnt(0:3,nexternal,-2:2)
      double precision wgt_cnt(-2:2)
      double precision pswgt_cnt(-2:2)
      double precision jac_cnt(-2:2)
      common/counterevnts/p1_cnt,wgt_cnt,pswgt_cnt,jac_cnt

      double precision p_born(0:3,nexternal-1)
      common/pborn/p_born

      double precision p_ev_red(0:3,nexternal-1)
      common/cpevred/p_ev_red

      integer i_fks,j_fks
      common/fks_indices/i_fks,j_fks

      logical xexternal
      common /toxexternal/ xexternal


      double precision xi_i_fks_ev,y_ij_fks_ev
      double precision p_i_fks_ev(0:3),p_i_fks_cnt(0:3,-2:2)
      common/fksvariables/xi_i_fks_ev,y_ij_fks_ev,p_i_fks_ev,p_i_fks_cnt

      integer run_cluster
      common/c_run_mode/run_cluster

c
c     External
c
      logical pass_point,passcuts
      logical check_swap
      double precision dsig,fks_sij,dsig2
      external pass_point,passcuts, dsig,fks_sij,dsig2
      external check_swap

c      integer icomp
c
c     DATA
c
      integer tprid(-max_branch:-1,lmaxconfigs)
      include 'configs.inc'
      integer mapbconf(0:lmaxconfigs)
      integer b_from_r(lmaxconfigs)
      integer r_from_b(lmaxconfigs)
      include 'bornfromreal.inc'
      include 'fks_powers.inc'


c helicity stuff
      integer          isum_hel
      logical                    multi_channel
      common/to_matrix/isum_hel, multi_channel

c-----
c  Begin Code
c-----
      write (*,'(a)') "Setting-up ajob's..."
      write (*,'(a)') "Give run mode and (adaptive) importance sampler:"
      write (*,'(a)') '"0" for local run, "1" for condor cluster'
      read  (*,*) run_cluster
      if (run_cluster.eq.0) then
         write (*,*) "Setting up ajob's for local run"
      elseif(run_cluster.eq.1) then
         write (*,*) "Setting up ajob's for condor cluster run"
      else
         write (*,*) "Invalid run mode", run_cluster
      endif

c      write(*,*) 'Enter compression (0=none, 1=sym, 2=BW, 3=full)'
c      read(*,*) icomp
c      if (icomp .gt. 3 .or. icomp .lt. 0) icomp=0
      if (icomp .eq. 0) then
         write(*,*) 'No compression, summing every diagram and ',
     $        'every B.W.'
      elseif (icomp .eq. 1) then
         write(*,*) 'Using symmetry but summing every B.W. '
      elseif (icomp .eq. 2) then
         write(*,*) 'Assuming B.W. but summing every diagram. '
      elseif (icomp .eq. 3) then
         write(*,*) 'Full compression. Using symmetry and assuming B.W.'
      else
         write(*,*) 'Unknown compression',icomp
         stop
      endif
      isum_hel=0
      multi_channel=.true.
      
      call setrun                !Sets up run parameters
      call setpara('param_card.dat',.true.)   !Sets up couplings and masses
      call setcuts               !Sets up cuts 
      call printout
      call run_printout
      iconfig=r_from_b(mapbconf(1))
      call setfksfactor(iconfig)
c
      ndim = 22
      ncall = 10000
      itmax = 10
      ninvar = 35
      nconfigs = 1
c      write (*,*) mapconfig(0)

      use_config(0)=0
c Read FKS configuration from file
      open (unit=61,file='config.fks',status='old')
      read(61,'(I2)',err=99,end=99) fksconfiguration
 99   close(61)
c Use the fks.inc include file to set i_fks and j_fks
      i_fks=fks_i(fksconfiguration)
      j_fks=fks_j(fksconfiguration)
      write (*,*) 'FKS configuration number is ',fksconfiguration
      write (*,*) 'FKS partons are: i=',i_fks,'  j=',j_fks
c
c     Start using all (Born) configurations
c
      do i=1,mapbconf(0)
         use_config(i)=1
      enddo


      include 'props.inc'
      call sample_init(ndim,ncall,itmax,ninvar,nconfigs)

      open(unit=lun,file='symswap.inc',status='unknown')

c     
c     Get momentum configuration
c
c Set xexternal to false to generate new xexternal in the x_to_f_arg subroutine
      xexternal=.false.

c Set-up helicities
      call get_helicity(i_fks,j_fks)

      do i = 1,3   !Not needed, but ok
      ntry = 1
      wgt=1d0
      call x_to_f_arg(ndim,iconfig,minconfig,maxconfig,ninvar,wgt,x,p)
      do while ((.not.passcuts(p,rwgt) .or. wgt .lt. 0 .or. p(0,1) .le. 0d0
     &           .or. p_born(0,1) .le. 0d0) .and. ntry .lt. 10000)
         call x_to_f_arg(ndim,iconfig,minconfig,maxconfig,ninvar,wgt,x,p)
         ntry=ntry+1
      enddo
      enddo
      call set_alphaS(p)
      write(*,*) 'ntry',ntry

c      return

c      xexternal=.true.
c      do j=2,mapbconf(j)
c      iconfig=r_from_b(mapbconf(j))
c      write (*,*)j,iconfig
c      call x_to_f_arg(ndim,iconfig,minconfig,maxconfig,ninvar,wgt,x,p)
c      write (*,*) p
c      enddo
      
c
c     Get and save base amplitudes
c
      if (onlyBorn) then
         call sborn(p_born,wgt1)
      else
         fx=dsig(p,wgt,1d0)/amp2(b_from_r(mapconfig(iconfig)))
      endif
      do j = 1 , mapbconf(0)
         if (onlyBorn) then
            saveamp(j) = amp2(j)
         else
            saveamp(j) = amp2(j)*fx
         endif
      enddo
      if (.not.onlyBorn) then
         write (*,*) '(n+1)-body momenta'
         do j=1,nexternal
            do i=0,3
               do k=-2,2
                  p1_cnt_save(i,j,k)=p1_cnt(i,j,k)
               enddo
            enddo
            write(*,'(i4,4e15.5)') j,(p(i,j),i=0,3)
         enddo
      endif
      write (*,*) 'born momenta'
      do j=1,nexternal-1
         do i=0,3
            p_born_save(i,j)=p_born(i,j)
            p_ev_red_save(i,j)=p_ev_red(i,j)
         enddo
         write(*,'(i4,4e15.5)') j,(p_born(i,j),i=0,3)
      enddo
c
c     Swap amplitudes looking for matches
c
c nexternal is the number for the real configuration. Subtract 1 for the Born.
      nswitch = 1
      do k=1,nexternal
         ic(k,1)=k
         if (k.ne.nexternal) icb(k,1)=k
      enddo
      nmatch = 0
      mtc=.false.
      nsym = 1
      write(lun,'(a,i3,a$)') 
     &     '       data (isym(i,',nsym,'),i=1,nexternal) /1 '
      do i=2,nexternal
         write(lun,'(a,i2$)') ",",ic(i,1)
c         write(*,'(a,i2$)') ",",ic(i,1)
      enddo
c      write(*,*)
      write(lun,'(a)') "/"
      if (.not.onlyBorn) then
         call nexper(nexternal-2,ic(3,1),mtc,even)
      else
         call nexper(nexternal-3,ic(3,1),mtc,even)
      endif
      
c      write(*,*) 'mtc',mtc, (ic(i,1),i=1,nexternal)
      do while(mtc)
         if (.not.onlyBorn) then
            call nexper(nexternal-2,ic(3,1),mtc,even)
         else
            call nexper(nexternal-3,ic(3,1),mtc,even)
         endif
c         write(*,*) 'mtc',mtc, (ic(i,1),i=1,nexternal)
         do j=3,nexternal
            ic(j,1)=ic(j,1)+2
         enddo
         do j=3,nexternal-1
            if (j.ge.max(i_fks,j_fks).and..not.onlyBorn) then
               icb(j,1)=ic(j+1,1)-1
            else
               icb(j,1)=ic(j,1)
            endif
         enddo
         if (mtc) then
c
c     Now check if it is a valid swap to make
c
         if (check_swap(ic(1,1))) then
            CALL SWITCHMOM(P,P1,IC(1,1),JC,NEXTERNAL)
            do i=-2,2
               CALL SWITCHMOM(P1_cnt_save(0,1,i),P1_cnt1(0,1,i),IC(1,1),JC,NEXTERNAL)
               do j=1,nexternal
                  do k=0,3
                     p1_cnt(k,j,i)=p1_cnt1(k,j,i)
                  enddo
               enddo
            enddo
            CALL SWITCHMOM(P_ev_red_save,P_ev_red1,ICB(1,1),JC,NEXTERNAL-1)
            CALL SWITCHMOM(P_born_save,P_born1,ICB(1,1),JC,NEXTERNAL-1)
            do j=1,nexternal-1
               do k=0,3
                  p_born(k,j)=p_born1(k,j)
                  p_ev_red(k,j)=p_ev_red1(k,j)
               enddo
            enddo

            write(*,*) 'Good swap', (ic(i,1),i=1,nexternal)
            write(*,*) '         ', (icb(i,1),i=1,nexternal-1)
            nsym=nsym+1
            write(lun,'(a,i3,a$)') 
     &           '       data (isym(i,',nsym,'),i=1,nexternal) /1 '
            do i=2,nexternal
               write(lun,'(a,i2$)') ",",ic(i,1)
            enddo
            write(lun,'(a)') "/"

            if (onlyBorn) then
               call sborn(p_born,wgt1)
            else
               fx = dsig(p1,wgt,1d0)/amp2(b_from_r(mapconfig(iconfig)))
            endif
            
            
c$$$            do j=1,nexternal-1
c$$$               write(*,'(i4,4e15.5)') j,(p_born(i,j),i=0,3)
c$$$            enddo
c$$$            write (*,*) (amp2(i),i=1,mapbconf(0))
c$$$            write (*,*) (saveamp(i),i=1,mapbconf(0))

c
c        Look for matches, but only for diagrams < current diagram
c     
         do j=2,mapbconf(0)
            do k=1,j-1
               if (onlyBorn) then
                  diff = abs((amp2(mapbconf(j)) - saveamp(mapbconf(k)))/
     $                 (amp2(mapbconf(j))+1d-99))
               else
                  diff = abs((amp2(mapbconf(j))*fx - saveamp(mapbconf(k)))/
     $                 (amp2(mapbconf(j))*fx+1d-99))
               endif
               if (diff .lt. 1d-8 ) then
c$$$                  write(*,*) "Found match graph",mapbconf(j),mapbconf(k),diff
                  if (use_config(j) .gt. 0 ) then  !Not found yet
                     nmatch=nmatch+1
                     if (use_config(k) .gt. 0) then !Match is real config
                        use_config(k)=use_config(k)+use_config(j)
                        use_config(j)=-k
                     else
                        ibase = -use_config(k)
                        use_config(ibase) = use_config(ibase)+use_config(j)
                        use_config(j) = -ibase
                     endif
                  endif
               endif
            enddo
         enddo
         else
            write(*,*) 'Bad swap', (ic(i,1),i=1,nexternal)
c$$$            write(*,*) '         ', (icb(i,1),i=1,nexternal-1)
         endif   !Good Swap
         endif   !Real Swap
         do j=3,nexternal
            ic(j,1)=ic(j,1)-2
         enddo
      enddo


      write(lun,*) '      data nsym /',nsym,'/'
      close(lun)
      write(*,*) 'Found ',nmatch, ' matches. ',mapbconf(0)-nmatch,
     $     ' channels remain for integration.'
      call write_bash(mapbconf,mapconfig,r_from_b,
     &                use_config,pwidth,icomp,biforest)
      call write_input(j)
      end

      subroutine store_events()
c**********************************************************************
c     Dummy routine
c**********************************************************************
      end

      subroutine write_symswap
c***********************************************************************
c     This information is used to symmeterize identical particle
c     data
c***********************************************************************
c      implicit none
c      
c      open(unit=lun,file='symswap.inc',status='unknown')
c      write(lun,*) '      data nsym /1/'
c      write(lun,'(a$)') '       data (isym(i,1),i=1,nexternal) /1 '
c      do i=2,nexternal
c         write(lun,'(a,i2$)') ",",i
c      enddo
c      write(lun,'(a)') "/"
c      close(lun)
      end

      logical function check_swap(ic)
c**************************************************************************
c     check that only identical particles were swapped
c**************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include "nexternal.inc"
      integer    maxflow
      parameter (maxflow=999)
c
c     Arguments
c
      integer ic(nexternal)
c
c     local
c
      integer i
      integer idup(nexternal,maxproc)
      integer mothup(2,nexternal,maxproc)
      integer icolup(2,nexternal,maxflow)
c
c     Process info
c
      include 'leshouche.inc'

      integer i_fks,j_fks
      common/fks_indices/i_fks,j_fks

      include 'fks_powers.inc'

c------
c Begin Code
c-----
      check_swap=.true.
      if (.not.onlyBorn) then
         do i=1,nexternal
            if (idup(i,1) .ne. idup(ic(i),1)) check_swap=.false.
         enddo
         if (i_fks .ne. ic(i_fks)) check_swap=.false.
         if (j_fks .ne. ic(j_fks)) check_swap=.false.
      endif
      end

      subroutine nexper(n,a,mtc,even)
c*******************************************************************************
c     Gives all permutations for a group
c http://www.cs.sunysb.edu/~algorith/implement/wilf/distrib/processed/nexper_2.f
c next permutation of {1,...,n}. Ref NW p 59.
c*******************************************************************************
      integer a(n),s,d
      logical mtc,even
      if(mtc)goto 10
      nm3=n-3
      do 1 i=1,n
 1        a(i)=i
      mtc=.true.
 5     even=.true.
      if(n.eq.1)goto 8
 6     if(a(n).ne.1.or.a(1).ne.2+mod(n,2))return
      if(n.le.3)goto 8
      do 7 i=1,nm3
      if(a(i+1).ne.a(i)+1)return
 7     continue
 8      mtc=.false.
      return
 10    if(n.eq.1)goto 27
      if(.not.even)goto 20
      ia=a(1)
      a(1)=a(2)
      a(2)=ia
      even=.false.
      goto 6
 20    s=0
      do 26 i1=2,n
 25       ia=a(i1)
      i=i1-1
      d=0
      do 30 j=1,i
 30       if(a(j).gt.ia) d=d+1
      s=d+s
      if(d.ne.i*mod(s,2)) goto 35
 26    continue
 27     a(1)=0
      goto 8
 35    m=mod(s+1,2)*(n+1)
      do 40 j=1,i
      if(isign(1,a(j)-ia).eq.isign(1,a(j)-m))goto 40
      m=a(j)
      l=j
 40    continue
      a(l)=ia
      a(i1)=m
      even=.true.
      return
      end


      integer function n_unwgted()
c
c     dummy routine
c     
      n_unwgted = 1
      end

      subroutine clear_events()
      end

       subroutine write_input(nconfigs)
c***************************************************************************
c     Writes out input file for approximate calculation based on the
c     number of active configurations
c***************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include "nexternal.inc"
      include '../../Source/run_config.inc'
      integer    maxpara
      parameter (maxpara=1000)
c      integer   npoint_tot,         npoint_min
c      parameter (npoint_tot=50000, npoint_min=1000)
c
c     Arguments
c
      integer nconfigs
c
c     local
c
      integer npoints
      character*20 param(maxpara),value(maxpara)
      integer npara, nreq
      logical gridpack
c-----
c  Begin Code
c-----
      call load_para(npara,param,value)
      call get_logical(npara,param,value," gridpack ",gridpack,.false.)

      npoints = min_events_subprocess/nconfigs
      npoints = max(npoints,min_events_channel)
      open (unit=26, file = 'input_app.txt', status='unknown',
     $     err=99)
      if (gridpack) then
         write(26,*) npoints_wu,itmax_wu,
     &     '     !Number of events and iterations'      
         write(26,'(f8.4,a)') acc_wu, '    !Accuracy'
         write(26,*) ' 2       !Grid Adjustment 0=none'
      else
         write(26,*) npoints,iter_survey,
     &     '     !Number of events and iterations'      
         write(26,*) ' 0.0    !Accuracy'
         write(26,*) ' 0       !Grid Adjustment 0=none'
      endif
      write(26,*) ' 1       !Suppress Amplitude 1=yes'
      write(26,*) nhel_survey,'       !Helicity Sum/event 0=exact'
      close(26)
      return
 99   close(26)
      write(*,*) 'Error opening input_app.txt'
      end

      subroutine write_bash(mapconfig,mapRconfig,r_from_b,
     &                      use_config, pwidth, jcomp,iforest)
c***************************************************************************
c     Writes out bash commands to run integration over all of the various
c     configurations, but only for "non-identical" configurations.
c     Also labels multiplication factor for each used configuration
c***************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include "nexternal.inc"
      include '../../Source/run_config.inc'
      integer    imax,   ibase
      parameter (imax=max_branch-1, ibase=3)
c
c     Arguments
c
      integer mapconfig(0:lmaxconfigs),mapRconfig(0:lmaxconfigs)
      integer use_config(0:lmaxconfigs)
      double precision pwidth(-max_branch:-1,lmaxconfigs)  !Propagotor width
      integer iforest(2,-max_branch:-1,lmaxconfigs)
      integer jcomp
      integer r_from_b(lmaxconfigs)

c
c     local
c
      integer i, j, nbw, ic, icode
      integer iarray(imax)
      logical lconflict(-max_branch:nexternal)
      logical done
      logical gForceBW(-max_branch:-1,lmaxconfigs)  ! Forced BW
      include 'born_decayBW.inc'

c-----
c  Begin Code
c-----
      call open_bash_file(26)
      ic = 0      
      do i=1,mapconfig(0)
         if (use_config(i) .gt. 0) then
            call bw_conflict(i,iforest(1,-max_branch,i),lconflict)
            nbw=0               !Look for B.W. resonances
            if (jcomp .eq. 0 .or. jcomp .eq. 1 .or. .true.) then
               do j=1,imax
                  iarray(j)=0   !Assume no cuts on BW
               enddo
               do j=1,nexternal-3
c                  write(*,*) 'Width',pwidth(-j,i),j,i
                  if (pwidth(-j,i) .gt. 1d-20) then
                     nbw=nbw+1
                     write(*,*) 'Got bw',-nbw,j
                     if(lconflict(-j).or.gForceBW(-j,i)) then
                        if(lconflict(-j)) write(*,*) 'Got conflict ',-nbw,j
                        if(gForceBW(-j,i)) write(*,*) 'Got forced BW ',-nbw,j
                        iarray(nbw)=1 !Cuts on BW
                        if (nbw .gt. imax) then
                           write(*,*) 'Too many BW w conflicts',nbw,imax
                        endif
                     endif
                  endif
               enddo
            endif
c            do j=1,2**nbw
            done = .false.
            do while (.not. done)
               call enCode(icode,iarray,ibase,imax)
               ic=ic+1
               if (ic .gt. ChanPerJob) then
                  call close_bash_file(26)
                  call open_bash_file(26)
                  ic = 1
               endif
c               write(*,*) 'mapping',ic,mapconfig(i)
               if (r_from_b(mapconfig(i)) .lt. 10) then
                  write(26,'(i1$)') r_from_b(mapconfig(i))
               elseif (r_from_b(mapconfig(i)) .lt. 100) then
                  write(26,'(i2$)') r_from_b(mapconfig(i))
               elseif (r_from_b(mapconfig(i)) .lt. 1000) then
                  write(26,'(i3$)') r_from_b(mapconfig(i))
               elseif (r_from_b(mapconfig(i)) .lt. 10000) then
                  write(26,'(i4$)') r_from_b(mapconfig(i))
               endif
               if (icode .eq. 0) then
c                 write(26,'($a)') '.000'
               elseif (icode .lt. 10) then
                  write(26,'(a,i1$)') '.00', icode
               elseif (icode .lt. 100) then
                  write(26,'(a,i2$)') '.0', icode
               elseif (icode .lt. 1000) then
                  write(26,'(a,i3$)') '.', icode
               else
                  write(*,*) 'Error too many B.W. in symmetry.f',icode
                  stop
               endif
               write(26,'(a$)') ' '
               call bw_increment_array(iarray,imax,ibase,gForceBW(-imax,i),done)
            enddo
         endif
      enddo
      call close_bash_file(26)
      if (mapconfig(0) .gt. 9999) then
         write(*,*) 'Only writing first 9999 jobs',mapconfig(0)
      endif
c
c     Now write out the symmetry factors for each graph
c
      open (unit=26, file = 'symfact.dat', status='unknown')
      do i=1,mapconfig(0)
         if (use_config(i) .gt. 0) then
c
c        Need to write appropriate number of BW sets this is
c        same thing as above for the bash file
c
            call bw_conflict(i,iforest(1,-max_branch,i),lconflict)
            nbw=0               !Look for B.W. resonances
            if (jcomp .eq. 0 .or. jcomp .eq. 1 .or. .true.) then
               do j=1,imax
                  iarray(j)=0   !Assume no cuts on BW
               enddo
               do j=1,nexternal-3
                  if (pwidth(-j,i) .gt. 1d-20) then
                     nbw=nbw+1
                     write(*,*) 'Got bw',nbw,j
                     if(lconflict(-j).or.gForceBW(-j,i)) then
                        iarray(nbw)=1 !Cuts on BW
                        if (nbw .gt. imax) then
                           write(*,*) 'Too many BW w conflicts',nbw,imax
                        endif
                     endif
                  endif
               enddo
            endif            
            done = .false.
            do while (.not. done)
               call enCode(icode,iarray,ibase,imax)
               if (icode .gt. 0) then
                  write(26,'(f9.3,i6)') mapconfig(i)+real(icode)/1000.,
     $                 use_config(i)
               else
                  write(26,'(2i6)') mapconfig(i),use_config(i)
               endif
               call bw_increment_array(iarray,imax,ibase,gForceBW(-imax,i),done)
            enddo
         else
            write(26,'(2i6)') mapconfig(i),-mapconfig(-use_config(i))
         endif
      enddo
      end


      subroutine BW_Conflict(iconfig,itree,lconflict)
c***************************************************************************
c     Determines which BW conflict
c***************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include "nexternal.inc"
      double precision zero
      parameter       (zero=0d0)
c      include '../../Source/run_config.inc'
c
c     Arguments
c
      integer itree(2,-max_branch:-1),iconfig
      logical lconflict(-max_branch:nexternal)

c
c     local
c
      integer i,j
      double precision pwidth(-max_branch:-1,lmaxconfigs)  !Propagator width
      double precision pmass(-max_branch:-1,lmaxconfigs)   !Propagator mass
      double precision pow(-max_branch:-1,lmaxconfigs)    !Not used, in props.inc
      double precision xmass(-max_branch:nexternal)
c
c     Global
c
      include 'coupl.inc'                     !Mass and width info
c-----
c  Begin Code
c-----
      include 'born_props.inc'   !Propagator mass and width information pmass,pwidth
      write(*,*) 'Checking for BW ',iconfig
c
c     Reset variables
c      
      do i=1,nexternal
         xmass(i) = 0d0
         lconflict(-i) = .false.
      enddo
c
c     Start by determining which propagators are part of the same 
c     chain, or could potentially conflict
c
      i=1
      do while (i .lt. nexternal-2 .and. itree(1,-i) .ne. 1)
         xmass(-i) = xmass(itree(1,-i))+xmass(itree(2,-i))
         if (pwidth(-i,iconfig) .gt. 0d0) then
            if (xmass(-i) .gt. pmass(-i,iconfig)) then  !Can't be on shell
               lconflict(-i)=.true.
               write(*,*) "Found Conflict", iconfig,i,
     $              pmass(-i,iconfig),xmass(-i)
            endif
         endif
         xmass(-i) = max(xmass(-i),pmass(-i,iconfig)+3d0*pwidth(-i,iconfig))        
         i=i+1
      enddo
c
c     Mark all daughters of conflicted BW as conflicting
c
      do j=i,1,-1
         if (lconflict(-j)) then 
            lconflict(itree(1,-j)) = .true.
            lconflict(itree(2,-j)) = .true.
            write(*,*) 'Adding conflict ',itree(1,-j),itree(2,-j)
         endif
      enddo
c
c     Only include BW props as conflicting
c
      do j=i,1,-1
         if (lconflict(-j)) then 
            if (pwidth(-j,iconfig) .le. 0) then 
               lconflict(-j) = .false.
               write(*,*) 'No conflict BW',iconfig,j
            else
               write(*,*) 'Conflicting BW',iconfig,j
            endif
         endif
      enddo                  

      end




      subroutine bw_increment_array(iarray,imax,ibase,force,done)
c************************************************************************
c     Increments iarray     
c************************************************************************
      implicit none
c
c     Arguments
c
      integer imax          !Input, number of elements in iarray
      integer ibase         !Base for incrementing, 0 is skipped
      logical force(imax)   !Force onshell BW, counting from -imax to -1
      integer iarray(imax)  !Output:Array of values being incremented
      logical done          !Output:Set when no more incrementing

c
c     Global
c
      include 'genps.inc'
      include "nexternal.inc"

c
c     Local
c
      integer i,j
      logical found
c-----
c  Begin Code
c-----
      found = .false.
      i = 1
      do while (i .le. imax .and. .not. found)
         if (iarray(i) .eq. 0) then    !don't increment this
            i=i+1
         elseif (iarray(i) .lt. ibase-1 .and. .not. force(imax+1-i)) then
            found = .true.
            iarray(i)=iarray(i)+1
         else
            iarray(i)=1
            i=i+1
         endif
      enddo
      done = .not. found
      end

      subroutine open_bash_file(lun)
c***********************************************************************
c     Opens bash file for looping including standard header info
c     which can be used with pbs, or stand alone
c***********************************************************************
      implicit none
c
c     Constants
c
      include '../../Source/run_config.inc'
c
c     Arguments
c
      integer lun
c
c     Local
c
      integer ic

      data ic/0/

      character*30 mname
      character*30 fname
      common/to_close_bash_file/fname

      integer run_cluster
      common/c_run_mode/run_cluster

c-----
c  Begin Code
c-----
      ic=ic+1
      fname='ajob'
      mname='mg'
      if (ic .lt. 10) then
         write(fname(5:5),'(i1)') ic
         write(mname(3:7),'(i1,a4)') ic,".cmd"
      elseif (ic .lt. 100) then
         write(fname(5:6),'(i2)') ic
         write(mname(3:8),'(i2,a4)') ic,".cmd"
      elseif (ic .lt. 1000) then
         write(fname(5:7),'(i3)') ic
         write(mname(3:9),'(i3,a4)') ic,".cmd"
      endif
      open (unit=lun, file = fname, status='unknown')
      if (run_cluster.eq.0) then
         write(lun,15) '#!/bin/bash'
         write(lun,15) 'script=' // fname
         write(lun,15) 'rm -f wait.$script >& /dev/null'
         write(lun,15) 'touch run.$script'
         write(lun,15) 'echo $script'
         write(lun,'(a$)') 'for i in '
      elseif(run_cluster.eq.1) then
         write(lun,15) '#!/bin/bash'
         write(lun,15) 'if [ -n "$_CONDOR_SCRATCH_DIR" ]; then'
         write(lun,15) '    CONDOR_INITIAL_DIR=`pwd`'
         write(lun,15) '    cd $_CONDOR_SCRATCH_DIR'
         write(lun,15) 'fi'
         write(lun,15) 'mkdir lib'
         write(lun,15) 'mkdir Cards'
         write(lun,15) 'mkdir SubProcesses'
         write(lun,15) 'cp -a  $CONDOR_INITIAL_DIR/'//
     &        '../../MGMEVersion.txt .'
         write(lun,15) 'cp -ra  $CONDOR_INITIAL_DIR/'//
     &        '../../Source .'
         write(lun,15) 'cp -ra  $CONDOR_INITIAL_DIR/'//
     &        '../../Cards/* ./Cards/'
         write(lun,15) 'cp -ra  $CONDOR_INITIAL_DIR/'//
     &        '../../lib/Pdfdata ./lib/'

         write(lun,15) "if [[ $1 == '0' ]]; then"
         write(lun,15) '    cp -a  $CONDOR_INITIAL_DIR/'//
     &           'madevent_vegas ./SubProcesses'
         write(lun,15) "elif [[ $1 == '1' ]]; then"
         write(lun,15) '    cp -a  $CONDOR_INITIAL_DIR/'//
     &           'madevent_mint ./SubProcesses'
         write(lun,15) "elif [[ $1 == '2' ]]; then"
         write(lun,15) '    cp -a  $CONDOR_INITIAL_DIR/'//
     &           'madevent_mintMC ./SubProcesses'
         write(lun,15) "fi"

         write(lun,15) 'cd SubProcesses'
         write(lun,'(a$)') 'for i in '
      endif

      if (run_cluster.eq.1) then
         open (unit=lun+1,file=mname,status='unknown')
         write(lun+1,15) 'universe = vanilla'
         write(lun+1,15) 'executable = '//fname
         write(lun+1,15) 'output = /dev/null'
         write(lun+1,15) 'error = /dev/null'
         write(lun+1,15) 'requirements = (MADGRAPH == True)'
         write(lun+1,15) 'log = /dev/null'
         write(lun+1,15) ''
         write(lun+1,15) 'queue'
         write(lun+1,15) ''
         close(lun+1)
      endif

 15   format(a)
      end

      subroutine close_bash_file(lun)
c***********************************************************************
c     Opens bash file for looping including standard header info
c     which can be used with pbs, or stand alone
c***********************************************************************
      implicit none
c
c     Constants
c
c
c     Constants
c
c     Arguments
c
      integer lun
c
c     local
c
      integer ic,j

      data ic/0/

      character*30 fname
      common/to_close_bash_file/fname
      integer run_cluster
      common/c_run_mode/run_cluster

c-----
c  Begin Code
c-----

      write(lun,'(a)') '; do'
c
c     Now write the commands
c      
      if (run_cluster.eq.0) then
         write(lun,20) 'echo $i'
         write(lun,20) 'echo $i >& run.$script'
c madevent_vegas or madevent_mint
         write(lun,20) "if [[ $1 == '0' || $1 == '1' ]]; then"
         write(lun,25) 'j=$2\_G$i'
         write(lun,25) 'if [[ ! -e $j ]]; then'
         write(lun,30) 'mkdir $j'
         write(lun,25) 'fi'
         write(lun,25) 'cd $j'
         write(lun,25) 'if [[ "$3" != "" ]]; then'
         write(lun,30) 'if [[ -e ../$3\_G$i ]]; then'
         write(lun,35) 'cp -f ../$3\_G$i/*.sv1 .'
         write(lun,30) 'else'
         write(lun,35) 'echo "Cannot find direcotry ../$3\_G$i/"'//
     &        ' > log.txt'
         write(lun,35) 'exit'
         write(lun,30) 'fi'
         write(lun,25) 'fi'
c madevent_mintMC
         write(lun,20) "elif [[ $1 == '2' ]]; then"
         write(lun,25) 'j=G$2$i'
         write(lun,25) 'if [[ ! -e $j ]]; then'
         write(lun,30) 'mkdir $j'
         write(lun,25) 'fi'
         write(lun,25) 'cd $j'
         write(lun,25) 'if [[ "$3" != "" ]]; then'
         write(lun,30) 'if [[ -e ../G$3$i ]]; then'
         write(lun,35) 'cp -f ../G$3$i/mint_grids ./preset_mint_grids'
         write(lun,30) 'else'
         write(lun,35) 'echo "Cannot find direcotry ../G$3$i/"'//
     &        ' > log.txt'
         write(lun,35) 'exit'
         write(lun,30) 'fi'
         write(lun,25) 'fi'
c endif
         write(lun,20) "fi"

         write(lun,20) 'cp ../config.fks .'
         write(lun,20) 'cp ../integrate.fks .'
         write(lun,20) 'cp ../nbodyonly.fks .'
         write(lun,20) 'cp ../iproc.dat .'
         write(lun,20) 'if [[ -e ../../randinit ]]; then'
         write(lun,25) 'cp ../../randinit .'
         write(lun,20) 'fi'
         write(lun,20) 'cp ../symfact.dat .'
         write(lun,20) 'if [[ -e ../HelasNLO.input ]]; then'
         write(lun,25) 'cp -f ../HelasNLO.input .'
         write(lun,20) 'fi'
         write(lun,20) 'if [[ -e ../MadLoop.param ]]; then'
         write(lun,25) 'cp -f ../MadLoop.param .'
         write(lun,20) 'fi'
         write(lun,20) 'if [[ -e ../order.file ]]; then'
         write(lun,25) 'cp -f ../order.file .'
         write(lun,20) 'fi'
c madevent_vegas
         write(lun,20) "if [[ $1 == '0' ]]; then"
         write(lun,25) 'head -n 5 ../../madin.$2 >& input_app.txt'
         write(lun,25) 'echo $i >> input_app.txt'
         write(lun,25) 'tail -n 4 ../../madin.$2 >> input_app.txt'
         write(lun,25) 'time ../madevent_vegas > log.txt <input_app.txt'
c madevent_mint
         write(lun,20) "elif [[ $1 == '1' ]]; then"
         write(lun,25) 'head -n 5 ../../madinM.$2 >& input_app.txt'
         write(lun,25) 'echo $i >> input_app.txt'
         write(lun,25) 'tail -n 3 ../../madinM.$2 >> input_app.txt'
         write(lun,25) 'time ../madevent_mint > log.txt <input_app.txt'
c madevent_mintMC
         write(lun,20) "elif [[ $1 == '2' ]]; then"
         write(lun,25) 'head -n 6 ../../madinMMC_$2.2 >& input_app.txt'
         write(lun,25) 'echo $i >> input_app.txt'
         write(lun,25) 'tail -n 4 ../../madinMMC_$2.2 >> input_app.txt'
         write(lun,25) 'time ../madevent_mintMC > log.txt <input_app.txt'
c endif
         write(lun,20) "fi"
         write(lun,20) 'cd ../'
         write(lun,15) 'done'
         write(lun,15) 'rm -f run.$script'
         write(lun,15) 'touch done.$script'

      elseif(run_cluster.eq.1) then
c madevent_vegas or madevent_mint
         write(lun,20) "if [[ $1 == '0' || $1 == '1' ]]; then"
         write(lun,25) 'j=$2\_G$i'
         write(lun,25) 'if [[ ! -e $j ]]; then'
         write(lun,30) 'mkdir $j'
         write(lun,25) 'fi'
         write(lun,25) 'cd $j'
         write(lun,25) 'cp -f $CONDOR_INITIAL_DIR/$j/* .'
         write(lun,25) 'if [[ "$3" != "" ]]; then'
         write(lun,30) 'if [[ -e $CONDOR_INITIAL_DIR/$3\_G$i ]]; then'
         write(lun,35) 'cp -f $CONDOR_INITIAL_DIR/$3\_G$i/*.sv1 .'
         write(lun,30) 'else'
         write(lun,35) 'echo "Cannot find direcotry ../$3\_G$i/"'//
     &        ' > log2.txt'
         write(lun,30) 'fi'
         write(lun,25) 'fi'

c madevent_mintMC
         write(lun,20) "elif [[ $1 == '2' ]]; then"
         write(lun,25) 'j=G$2$i'
         write(lun,25) 'if [[ ! -e $j ]]; then'
         write(lun,30) 'mkdir $j'
         write(lun,25) 'fi'
         write(lun,25) 'cd $j'
         write(lun,25) 'cp -f $CONDOR_INITIAL_DIR/$j/* .'
c endif
         write(lun,20) "fi"

         write(lun,20) 'cp -f $CONDOR_INITIAL_DIR/config.fks .'
         write(lun,20) 'cp -f $CONDOR_INITIAL_DIR/iproc.dat .'
         write(lun,20)
     &        'if [[ -e $CONDOR_INITIAL_DIR/../randinit ]]; then'
         write(lun,25) 'cp -f $CONDOR_INITIAL_DIR/../randinit .'
         write(lun,20) 'fi'
         write(lun,20) 'cp -f $CONDOR_INITIAL_DIR/integrate.fks .'
         write(lun,20) 'cp -f $CONDOR_INITIAL_DIR/nbodyonly.fks .'
         write(lun,20) 'cp -f $CONDOR_INITIAL_DIR/symfact.dat .'
         write(lun,20)
     &        'if [[ -e $CONDOR_INITIAL_DIR/HelasNLO.input ]]; then'
         write(lun,25) 'cp -f $CONDOR_INITIAL_DIR/HelasNLO.input .'
         write(lun,20) 'fi'
         write(lun,20)
     &        'if [[ -e $CONDOR_INITIAL_DIR/MadLoop.param ]]; then'
         write(lun,25) 'cp -f $CONDOR_INITIAL_DIR/MadLoop.param .'
         write(lun,20) 'fi'
         write(lun,20)
     &        'if [[ -e $CONDOR_INITIAL_DIR/order.file ]]; then'
         write(lun,25) 'cp -f $CONDOR_INITIAL_DIR/order.file .'
         write(lun,20) 'fi'

c madevent_vegas
         write(lun,20) "if [[ $1 == '0' ]]; then"
         write(lun,25) 'head -n 5 $CONDOR_INITIAL_DIR/'//
     &        '../madin.$2 >& input_app.txt'
         write(lun,25) 'echo $i >> input_app.txt'
         write(lun,25) 'tail -n 4 $CONDOR_INITIAL_DIR/'//
     &        '../madin.$2 >> input_app.txt'
         write(lun,25) 'time ../madevent_vegas > log.txt <input_app.txt'
c madevent_mint
         write(lun,20) "elif [[ $1 == '1' ]]; then"
         write(lun,25) 'head -n 5 $CONDOR_INITIAL_DIR/'//
     &        '../madinM.$2 >& input_app.txt'
         write(lun,25) 'echo $i >> input_app.txt'
         write(lun,25) 'tail -n 3 $CONDOR_INITIAL_DIR/'//
     &        '../madinM.$2 >> input_app.txt'
         write(lun,25) 'time ../madevent_vegas > log.txt <input_app.txt'
c madevent_mintMC
         write(lun,20) "elif [[ $1 == '2' ]]; then"
         write(lun,25) 'head -n 6 $CONDOR_INITIAL_DIR/'//
     &        '../madinMMC_$2.2 >& input_app.txt'
         write(lun,25) 'echo $i >> input_app.txt'
         write(lun,25) 'tail -n 4 $CONDOR_INITIAL_DIR/'//
     &        '../madinMMC_$2.2 >> input_app.txt'
         write(lun,25)'time ../madevent_mintMC > log.txt <input_app.txt'
c endif
         write(lun,20) "fi"

         write(lun,20) 'cd ../'
         write(lun,15) 'done'
c madevent_vegas or madevent_mint
         write(lun,15) "if [[ $1 == '0' || $1 == '1' ]]; then"
         write(lun,20) 'cp -ar $2\_G* $CONDOR_INITIAL_DIR/'
c madevent_mintMC
         write(lun,15) "elif [[ $1 == '2' ]]; then"
         write(lun,20) 'cp -ar G$2* $CONDOR_INITIAL_DIR/'
         write(lun,20) 
c endif
         write(lun,15) "fi"
      endif
      
 15   format(a)
 20   format(4x,a)
 25   format(8x,a)
 30   format(12x,a)
 35   format(16x,a)
      close(lun)
      end

c
c
c Dummy routines
c
c
      subroutine outfun(pp,www,iplot)
      end
      logical function pass_point(p)
      pass_point = .true.
      end
      LOGICAL FUNCTION PASSCUTS(P,rwgt)
      real*8 rwgt
      real*8 p(0:3,99)
      rwgt=1d0
      passcuts=.true.
      RETURN
      END

