C+-----------------------------------------------------------------------+
C|                         MAIN CODE FOR MADWEIGHT                       |
C|                                                                       |
C|     Author: Pierre Artoisenet (UCL-CP3)                               |
C|             Olivier Mattelaer (UCL-CP3)                               |
C+-----------------------------------------------------------------------+
C|     This file is generated automaticly by MADWEIGHT-ANALYZER          |
C+-----------------------------------------------------------------------+     
      subroutine main_code(x,n_var)
C+-----------------------------------------------------------------------+
C|     Central Routine for the change of variable choice                 |
C|       - num_sol: number of the solution to charge                     |
C|       - x      : random number from vegas                             |
C+-----------------------------------------------------------------------+

	integer config,perm_pos
	common /to_config/ config,perm_pos
	double precision x(20)
	integer n_var
	double precision    S,X1,X2,PSWGT,JAC
        common /PHASESPACE/ S,X1,X2,PSWGT,JAC
c
	double precision multi_channel_weight
	external multi_channel_weight
c
	include 'd_choices.inc'
C+-----------------------------------------------------------------------+
C|     Scedullar Part					                 |
C+-----------------------------------------------------------------------+    

       if (config.eq.1) then 

C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: A                                                           |
C|    particle in ECS : 3(visible)    6(visible)                         |
C|    blob linked are generated by :-1    -2                             |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+



        call block_d(x,n_var,first_d_4_5, second_d_4_5,-1)
        call block_stat(1,'D-4')
        if (jac.le.0d0) return

        call block_d(x,n_var,first_d_7_8, second_d_7_8,-2)
        call block_stat(2,'D-7')
        if (jac.le.0d0) return

        call class_a(x,n_var,3,6)
        call block_stat(3,'a-3')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(1)

       elseif (config.eq.2) then 

C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: A                                                           |
C|    particle in ECS : 3(visible)    6(visible)                         |
C|    blob linked are generated by :-1    -2                             |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+



        call fuse(4,5,-1)
        call block_stat(1,'1-4')
        if (jac.le.0d0) return

        call block_d(x,n_var,first_d_7_8, second_d_7_8,-2)
        call block_stat(2,'D-7')
        if (jac.le.0d0) return

        call class_a(x,n_var,3,6)
        call block_stat(3,'a-3')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(2)

       elseif (config.eq.3) then 

C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: A                                                           |
C|    particle in ECS : 3(visible)    6(visible)                         |
C|    blob linked are generated by :-1    -2                             |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+



        call block_d(x,n_var,first_d_4_5, second_d_4_5,-1)
        call block_stat(1,'D-4')
        if (jac.le.0d0) return

        call fuse(7,8,-2)
        call block_stat(2,'1-7')
        if (jac.le.0d0) return

        call class_a(x,n_var,3,6)
        call block_stat(3,'a-3')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(3)

       elseif (config.eq.4) then 

C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: A                                                           |
C|    particle in ECS : 3(visible)    6(visible)                         |
C|    blob linked are generated by :-1    -2                             |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+



        call fuse(4,5,-1)
        call block_stat(1,'1-4')
        if (jac.le.0d0) return

        call fuse(7,8,-2)
        call block_stat(2,'1-7')
        if (jac.le.0d0) return

        call class_a(x,n_var,3,6)
        call block_stat(3,'a-3')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(4)

       elseif (config.eq.5) then 

C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: A                                                           |
C|    particle in ECS : 3(visible)    4(visible)                         |
C|    blob linked are generated by :-2                                   |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+



        call block_d(x,n_var,first_d_7_8, second_d_7_8,-2)
        call block_stat(1,'D-7')
        if (jac.le.0d0) return

        call class_a(x,n_var,3,4)
        call block_stat(2,'a-3')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(5)

       elseif (config.eq.6) then 
C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: A                                                           |
C|    particle in ECS : 3(visible)    4(visible)                         |
C|    blob linked are generated by :-2                                   |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+



        call fuse(7,8,-2)
        call block_stat(1,'1-7')
        if (jac.le.0d0) return

        call class_a(x,n_var,3,4)
        call block_stat(2,'a-3')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(6)

       elseif (config.eq.7) then 
C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: A                                                           |
C|    particle in ECS : 3(visible)    5(visible)                         |
C|    blob linked are generated by :-2                                   |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+




        call block_d(x,n_var,first_d_7_8, second_d_7_8,-2)
        call block_stat(1,'D-7')
        if (jac.le.0d0) return

        call class_a(x,n_var,3,5)
        call block_stat(2,'a-3')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(7)

       elseif (config.eq.8) then 
C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: A                                                           |
C|    particle in ECS : 3(visible)    5(visible)                         |
C|    blob linked are generated by :-2                                   |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+




        call fuse(7,8,-2)
        call block_stat(1,'1-7')
        if (jac.le.0d0) return

        call class_a(x,n_var,3,5)
        call block_stat(2,'a-3')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(8)

       elseif (config.eq.9) then 
C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: A                                                           |
C|    particle in ECS : 6(visible)    7(visible)                         |
C|    blob linked are generated by :-3                                   |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+




        call block_d(x,n_var,first_d_4_5, second_d_4_5,-1)
        call block_stat(1,'D-4')
        if (jac.le.0d0) return

C       ++++++++++++           
        call block_d(x,n_var,3, -1, -3)
        call block_stat(2,'D-3')
        if (jac.le.0d0) return

        call class_a(x,n_var,6,7)
        call block_stat(3,'a-6')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(9)

       elseif (config.eq.10) then 
C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: A                                                           |
C|    particle in ECS : 6(visible)    7(visible)                         |
C|    blob linked are generated by :-3                                   |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+




        call block_e(x,n_var,5,4,3,-1,-3)
        call block_stat(1,'E-5')
        if (jac.le.0d0) return

        call class_a(x,n_var,6,7)
        call block_stat(2,'a-6')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(10)

       elseif (config.eq.11) then 
C+-----------------------------------------------------------------------+
C|                                                                       |
C|        ** Enlarged Contraint Sector global information **             |
C|                                                                       |
C|    Class: A                                                           |
C|    particle in ECS : 6(visible)    7(visible)                         |
C|    blob linked are generated by :-3                                   |
C|                                                                       |
C|                                                                       |
C+-----------------------------------------------------------------------+




        call fuse(4,5,-1)
        call block_stat(1,'1-4')
        if (jac.le.0d0) return

C       ++++++++++++           
        call fuse(3,-1,-3)
        call block_stat(2,'1-3')
        if (jac.le.0d0) return

        call class_a(x,n_var,6,7)
        call block_stat(3,'a-6')
        if (jac.le.0d0) return


        jac=jac*multi_channel_weight(11)

        endif
        return
        end
